<template>
  <div class="introduce">
    <div class="introduce-header">
      <img src="../assets/img/number_downloader.png" alt="number downloader" />
    </div>
    <div class="introduce-kols">
      <div class="portrait kols-slide opacity-animate-wrapper">
        <div
          v-for="(img, index) of listKols"
          :key="`ip-${index}`"
          :class="`kol-item opacity-animate portrait ${index === currentKolIndex ? 'opacity-animate-active' : ''}`"
        >
          <img :src="img" class="img-item" />
          <img class="img-watermark" src="../assets/img/watermark.png" />
        </div>
      </div>
      <div class="landscape kols-slide-landscape">
        <div v-for="(img, index) of listKols" :key="`il-${index}`" class="kol-item">
          <img class="img-item" :src="img" />
          <img class="img-watermark" src="../assets/img/watermark.png" />
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'nuxt-property-decorator';
import { commonModule, SlideName, Orientation } from '../store/common/const';
import {
  INTRODUCE_SLIDE_FADE_TIMEOUT,
  KOLS_PORTRAIT_VISUALS
} from '../constants';

@Component
export default class IntroduceComponent extends Vue {
  protected listKols: string[] = KOLS_PORTRAIT_VISUALS;
  protected time: number = INTRODUCE_SLIDE_FADE_TIMEOUT;
  protected currentKolIndex: number = 0;
  protected kolOptions: any = {
    autoplay: {
      delay: this.time,
      disableOnInteraction: false,
      autoplayStopOnLast: true
    },
    autoplayStopOnLast: true,
    effect: 'fade',
    speed: 400
  };
  protected interval: any;

  protected Orientation = Orientation;

  @commonModule.Action('changeToSlide')
  protected changeToSlide!: (slide: number) => void;

  @commonModule.State('currentSlide')
  public slide!: SlideName;

  @commonModule.State('orientation')
  protected orientation!: Orientation;

  @Watch('slide', { immediate: true })
  onChangeSlide(val: SlideName) {
    if (
      val === SlideName.Introduce &&
      this.orientation === Orientation.Portrait
    ) {
      this.swipeToLastSlide();
    } else {
      if (this.interval) {
        clearInterval(this.interval);
      }
    }
  }

  @Watch('orientation', { immediate: true })
  onChangeOrientation(val: Orientation) {
    if (this.slide === SlideName.Introduce) {
      if (val === Orientation.Landscape) {
        if (this.interval) {
          clearInterval(this.interval);
        }
      } else {
        this.swipeToLastSlide();
      }
    }
  }

  protected swipeToLastSlide() {
    this.currentKolIndex = 0;
    this.interval = setInterval(
      this.loopFadeEffect,
      INTRODUCE_SLIDE_FADE_TIMEOUT
    );
    setTimeout(() => {
      if (jQuery && jQuery.fn.fullpage.moveTo) {
        jQuery.fn.fullpage.moveTo(SlideName.DrawableImage);
        this.currentKolIndex = this.listKols.length - 1;
      }
    }, INTRODUCE_SLIDE_FADE_TIMEOUT * this.listKols.length);
  }

  loopFadeEffect() {
    if (this.currentKolIndex >= this.listKols.length - 1) {
      this.currentKolIndex = 0;
    } else {
      this.currentKolIndex++;
    }
  }
}
</script>

<style lang="scss" scoped>
.introduce {
  display: flex;
  flex-direction: column;
  justify-content: center;
  height: 100%;
  background: black url('../assets/img/spark.png') no-repeat center right;
  background-size: contain;
  background-position-y: 25%;

  .introduce-header {
    margin-bottom: 20px;
    display: flex;
    align-items: flex-end;
    justify-content: center;

    img {
      width: 90%;
      height: 12vh;
      max-height: 80px;
      object-fit: contain;
    }
  }

  .introduce-kols {
    .kols-slide {
      width: 100vw;
      height: 100vw;

      .kol-item {
        .img-item {
          position: absolute;
          top: 0;
          bottom: 0;
          left: 0;
          right: 0;
          width: 100%;
          height: 100%;
          object-fit: cover;
        }

        .img-watermark {
          position: absolute;
          bottom: 20%;
          left: 20%;
          width: 60%;
        }
      }
    }
  }
}

@include Orientation(Landscape) {
  .introduce {
    background: black url('../assets/img/spark_smoke_landscape.png') no-repeat
      center center;
    background-size: cover;

    .introduce-header {
      margin-bottom: 5vh;

      img {
        width: 50%;
        height: 20vh;
        max-width: 500px;
        max-height: initial;
      }
    }

    .introduce-kols {
      .kols-slide-landscape {
        display: flex;
        flex-direction: row;
        justify-content: center;
        align-items: center;
        margin: 0 auto;

        .kol-item {
          position: relative;
          width: 25vw;
          height: 25vw;
          margin: 0 2vh;
          padding: 0;

          .img-item {
            width: 100%;
            height: 100%;
            object-fit: cover;
          }

          .img-watermark {
            position: absolute;
            bottom: 20%;
            left: 20%;
            width: 60%;
          }
        }
      }
    }
  }
}
</style>
